Wt: Wt::WCssTheme Class Reference

Wt 3.3.0

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes

- Class List
- Class Hierarchy
- Class Members

Public Member Functions
Wt::WCssTheme Class Reference

`#include <Wt/WCssTheme>`

Inheritance diagram for Wt::WCssTheme:
[legend]

List of all members.

## Public Member Functions
| WCssTheme (const std::string &name, WObject *parent=0)
| Constructor.
virtual std::string | name () const
| Returns a theme name.
virtual std::vector < WCssStyleSheet > | styleSheets () const
| Returns a vector with stylesheets for the theme.
virtual void | apply (WWidget *widget, WWidget *child, int widgetRole) const
| Applies the theme to a child of a composite widget.
virtual void | apply (WWidget *widget, DomElement &element, int elementRole) const
| Applies the theme to a DOM element that renders a widget.
virtual std::string | disabledClass () const
| Returns a generic CSS class name for a disabled element.
virtual std::string | activeClass () const
| Returns a generic CSS class name for an active element.
virtual bool | canStyleAnchorAsButton () const
| Returns whether the theme allows for an anchor to be styled as a button.
virtual void | applyValidationStyle (WWidget *widget, const Wt::WValidator::Result &validation, WFlags< ValidationStyleFlag > styles) const
| Applies a style that indicates the result of validation.

## Detailed Description

CSS-based theme support. This implements the classic Wt themes, which were available before theme support was customized with the addition of the WTheme class.

The following table shows which style classes are applied by this theme.

WAbstractItemView * | .Wt-itemview |
.Wt-itemview .Wt-headerdiv | the header container
.Wt-itemview .Wt-header | the header
.Wt-itemview .Wt-header .Wt-label | a header label
.Wt-itemview .Wt-header .Wt-label | a header label
.Wt-itemview .Wt-tv-rh | resize handle
.Wt-itemview .Wt-tv-sh | sort handle
.Wt-itemview .Wt-tv-sh-none | sort handle, unsorted
.Wt-itemview .Wt-tv-sh-down | sort handle, descending sort
.Wt-itemview .Wt-tv-sh-up | sort handle, ascending sort
.Wt-itemview .Wt-selected | selected item (or row)
.Wt-itemview .Wt-spacer | spacer (briefly visible during scrolling)
WAbstractSpinBox | .Wt-spinbox | (for the HTML4 implementation)
WCalendar * | .Wt-cal |
.Wt-cal table.d1 | the table (single letter days)
.Wt-cal table.d3 | the table (three letter days)
.Wt-cal table.dlong | the table (ful day names)
.Wt-cal th.caption | a caption cell (containing month/year navigation)
.Wt-cal th | week day header cell
.Wt-cal td | day cell
.Wt-cal-oom | out-of-month day
.Wt-cal-oom | out-of-range day (ray < bottom or day > top)
.Wt-cal-sel | selected day
.Wt-cal-now | today
WDateEdit | .Wt-dateedit |
.Wt-datepicker | the popup
WDatePicker | .Wt-datepicker | the popup
WDialog | .Wt-dialog | the dialog
.Wt-dialog .closeicon | the close icon in the titlebar
.Wt-dialog .titlebar | the titlebar
.Wt-dialog .body | the dialog body
.Wt-dialog .footer | the dialog footer
WMenuItem | .item | an unselected item
.itemselected | a selected item
.item.Wt-closable | a closable item
.item.Wt-separator | a separator item
.item.Wt-sectheader | a section header item
.item .Wt-icon | the item's icon
.item .Wt-chkbox | the item's checkbox
.item .closeicon | the item's close icon
WMessageBox | .Wt-dialog | see supra (WDialog)
WPanel | .Wt-panel |
.Wt-panel .titlebar | the titlebar
.Wt-panel .body | the body
WPopupMenu | .Wt-popupmenu | the popup menu; for the items, see supra (WMenuItem)
WPopupWidget | .Wt-outset |
WProgressBar | .Wt-progressbar |
.Wt-progressbar .Wt-pgb-bar | the bar
.Wt-progressbar .Wt-pgb-label | the value label
WPushButton | .Wt-btn |
WSlider * | .Wt-slider-h or .Wt-slider-v | for horizontal or vertical slider
.Wt-slider-[hv] .Wt-slider-bg | background element
.Wt-slider-[hv] .fill | fill to the current value
.Wt-slider-[hv] .handle | the slider handle
.Wt-slider-[hv] .Wt-w | an additional element for styling
.Wt-slider-[hv] .Wt-e | an additional element for styling
WSuggestionPopup | .Wt-suggest |
.Wt-suggest li | an item
.Wt-suggest .active | an active item
WTabWidget | .Wt-tabs | the header, which is a WMenu
WTableView * | .Wt-tableview | see supra (WAbstractItemView)
.Wt-tableview .Wt-contents | the contents area
.Wt-tableview .Wt-contents .Wt-tv-c | a contents cell
WTreeNode * | .Wt-tree | a tree node
.Wt-tree.Wt-trunk | a trunk node
.Wt-tree.Wt-end | an end node (last node within parent)
.Wt-tree ul | children list
.Wt-tree .Wt-ctrl | collapse/expand control
.Wt-tree .Wt-ctrl.expand | expand control
.Wt-tree .Wt-ctrl.collapse | collapse control
.Wt-tree .Wt-ctrl.noexpand | an item that cannot be expanded
.Wt-tree .Wt-selected | a selected node
.Wt-tree .Wt-label | the label
WTreeView * | .Wt-treeview | see supra (WAbstractItemView)
.Wt-treeview ul | a node
.Wt-treeview ul.Wt-tv-root | the root node
.Wt-treeview .Wt-tv-row | a row of additional cells
.Wt-treeview .Wt-trunk | a trunk node
.Wt-treeview .Wt-end | an end node (last node within parent)
.Wt-treeview .Wt-ctrl | collapse/expand control
.Wt-treeview .Wt-ctrl.expand | expand control
.Wt-treeview .Wt-ctrl.collapse | collapse control
.Wt-treeview .Wt-ctrl.noexpand | an item that cannot be expanded

`*` CSS selectors for these widgets are currently still hard-coded in the widget itself.

See also:
  WApplication::setTheme()

## Constructor & Destructor Documentation

Wt::WCssTheme::WCssTheme | ( | const std::string & | name,
|  | WObject * | parent = `0`
| ) |  |

Constructor.

Creates a classic Wt theme ("polished" or "default").

## Member Function Documentation

void Wt::WCssTheme::apply | ( | WWidget * | widget,
|  | WWidget * | child,
|  | int | widgetRole
| ) |  | const`[virtual]`

Applies the theme to a child of a composite widget.

The `widgetRole` indicates the role that `child` has within the implementation of the `widget`.

Implements Wt::WTheme.

void Wt::WCssTheme::apply | ( | WWidget * | widget,
|  | DomElement & | element,
|  | int | elementRole
| ) |  | const`[virtual]`

Applies the theme to a DOM element that renders a widget.

The `element` is a rendered representation of the `widget`, and may be further customized to reflect the theme.

Implements Wt::WTheme.

std::string Wt::WCssTheme::name | ( |  | ) | const`[virtual]`

Returns a theme name.

Returns a unique name for the theme. This name is used by the default implementation of resourcesUrl() to compute a location for the theme's resources.

Implements Wt::WTheme.

std::vector< WCssStyleSheet > Wt::WCssTheme::styleSheets | ( |  | ) | const`[virtual]`

Returns a vector with stylesheets for the theme.

This should return a vector with stylesheets that implement the theme. This list may be tailored to the current user agent, which is read from the application environment.

Implements Wt::WTheme.

All Classes Namespaces Functions Variables Typedefs Enumerations Enumerator